BWFImportDescriptor (Media Authoring with Java API)
Date: 2016-02-05

tv.amwa.maj.model

## Interface BWFImportDescriptor

- All Superinterfaces:
    EssenceDescriptor, ImportDescriptor, InterchangeObject, MediaEntity, MetadataObject, PhysicalDescriptor
  All Known Implementing Classes:
    BWFImportDescriptorImpl

      public interface BWFImportDescriptor
      extends ImportDescriptor

  Specifies the description of audio essence that is formatted according the the Broadcast Wave Format specifications, which is a file essence source that is not directly manipulated by an AAF application.

- - ### Method Summary

    All Methods Instance Methods Abstract Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `appendUnknownBWFChunk(RIFFChunk chunk)` Append a RIFFChunk to end of the list of unknown BWF chunks of this BWF import descriptor.
    `void` | `clearUnknownBWFChunks()` Clear the unknown BWF chunks attached to this BWF import descriptor, omitting this optional property.
    `BWFImportDescriptor` | `clone()` Create a cloned copy of this BWF import descriptor.
    `int` | `countUnknownBWFChunks()` Returns the total number of unknown BWF chunks attached to this BWF import descriptor.
    `String` | `getBasicData()` Returns the basic data of this BWF import descriptor, which is taken from the basic data property of the associated <qlty> chunk.
    `String` | `getCodingHistory()` Returns the coding history property of this BWF import descriptor, which is taken from the coding history property of the associated <bext> chunk.
    `String` | `getCueSheet()` Returns the cue sheet property of this BWF import descriptor, which is taken from the cue sheet data property of the associated <qlty> chunk.
    `String` | `getEndOfModulation()` Returns the end of modulation property of this BWF import descriptor, which is taken from the end modulation data property of the associated <qlty> chunk.
    `int` | `getFileSecurityReport()` Returns the file security code of the quality report of this BWF import descriptor.
    `int` | `getFileSecurityWave()` Returns the file security code of the BWF wave data of this BWF import descriptor.
    `String` | `getOperatorComment()` Returns the operator comment property of this BWF import descriptor, which is taken from the comment of operator property of the associated <qlty> chunk.
    `String` | `getQualityEvent()` Returns the quality event data property of this BWF import descriptor, which is taken from the quality event data property of the associated <qlty> chunk.
    `String` | `getQualityParameter()` Returns the quality parameter property of this BWF import descriptor, which is taken from the quality parameter data property of the associated <qlty> chunk.
    `String` | `getStartOfModulation()` Returns the start of modulation data of this BWF import descriptor, which is taken from the start modulation data poperty of the associated <qlty> chunk.
    `RIFFChunk` | `getUnknownBWFChunkAt(int index)` Returns the RIFFChunk from the list of unknown BWF chunks of this BWF import descriptor at the given index.
    `List<? extends RIFFChunk>` | `getUnknownBWFChunks()` Returns a copy of the list of unknown BWF chunks of this BWF import descriptor.
    `void` | `insertUnknownBWFChunkAt(int index, RIFFChunk chunk)` Insert a RIFFChunk into the list of unknown BWF chunks of this BWF import descriptor at the given index.
    `void` | `prependUnknownBWFChunk(RIFFChunk chunk)` Prepend a RIFFChunk to the beginning of the list of unknown BWF chunks of this BWF descriptor.
    `void` | `removeUnknownBWFChunkAt(int index)` Removes the RIFFChunk at the given index through the list of unknown BWF chunks of this BWF descriptor.
    `void` | `setBasicData(String basicData)` Sets the basic data of this BWF import descriptor, which is taken from the basic data property of the associated <qlty> chunk.
    `void` | `setCodingHistory(String codingHistory)` Sets the coding history property of this BWF import descriptor, which is taken from the coding history property of the associated <bext> chunk.
    `void` | `setCueSheet(String cueSheet)` Sets the cue sheet property of this BWF import descriptor, which is taken from the cue sheet data property of the associated <qlty> chunk.
    `void` | `setEndOfModulation(String endOfModulation)` Sets the end of modulation property of this BWF import descriptor, which is taken from the end modulation data property of the associated <qlty> chunk.
    `void` | `setFileSecurityReport(Integer fileSecurityReport)` Set the file security code of the quality report of this BWF import descriptor.
    `void` | `setFileSecurityWave(Integer fileSecurityWave)` Sets the file security code of the BWF wave data of this BWF import descriptor.
    `void` | `setOperatorComment(String operatorComment)` Sets the operator comment property of this BWF import descriptor, which is taken from the comment of operator property of the associated <qlty> chunk.
    `void` | `setQualityEvent(String qualityEvent)` Sets the quality event data property of this BWF import descriptor, which is taken from the quality event data property of the associated <qlty> chunk.
    `void` | `setQualityParameter(String qualityParameter)` Sets the quality parameter property of this BWF import descriptor, which is taken from the quality parameter data property of the associated <qlty> chunk.
    `void` | `setStartOfModulation(String startOfModulation)` Sets the start of modulation data of this BWF import descriptor, which is taken from the start modulation data property of the associated <qlty> chunk.

    - ### Methods inherited from interface tv.amwa.maj.model.EssenceDescriptor

      `appendLocator, appendSubDescriptor, clearLocators, countLocators, countSubDescriptors, getLocatorAt, getLocators, getSubDescriptorAt, getSubDescriptors, insertLocatorAt, insertSubDescriptorAt, prependLocator, prependSubDescriptor, removeLocatorAt, removeSubDescriptorAt`

    - ### Methods inherited from interface tv.amwa.maj.model.InterchangeObject

      `addApplicationPlugin, clearApplicationPlugins, containsApplicationPlugin, containsApplicationPlugin, countApplicationPlugins, deepEquals, disableGenerationTracking, enableGenerationTracking, equals, getApplicationPlugins, getGeneration, getLinkedGenerationID, getObjectClass, isGenerationTracked, removeApplicationPlugin, removeApplicationPlugin, setLinkedGenerationID, setObjectClass, toString`

    - ### Methods inherited from interface tv.amwa.maj.industry.MediaEntity

      `getPersistentID, setPersistentIndex`

- - ### Method Detail

    - #### setFileSecurityReport

          void setFileSecurityReport(@UInt32
                                     Integer fileSecurityReport)

      Set the file security code of the quality report of this BWF import descriptor. This property is optional and can be omitted by setting its value to `null`.

      Parameters:
        `fileSecurityReport` - File security code of the quality report of this BWF import descriptor.

    - #### getFileSecurityReport

          @UInt32
          int getFileSecurityReport()
                                     throws PropertyNotPresentException

      Returns the file security code of the quality report of this BWF import descriptor. This property is optional.

      Returns:
        File security code of the quality report of this BWF import descriptor.
      Throws:
        `PropertyNotPresentException` - The optional file security code value is not present in this BWF import descriptor.

    - #### setFileSecurityWave

          void setFileSecurityWave(@UInt32
                                   Integer fileSecurityWave)

      Sets the file security code of the BWF wave data of this BWF import descriptor. This property is optional and can be omitted by setting its value to `null`.

      Parameters:
        `fileSecurityWave` - File security code of the BWF wave data of this BWF import descriptor.

    - #### getFileSecurityWave

          @UInt32
          int getFileSecurityWave()
                                   throws PropertyNotPresentException

      Returns the file security code of the BWF wave data of this BWF import descriptor. This property is optional.

      Returns:
        File security code of the BWF wave data of this BWF import descriptor.
      Throws:
        `PropertyNotPresentException` - The optional file security wave property is not present in this BWF import descriptor.

    - #### countUnknownBWFChunks

          @UInt32
          int countUnknownBWFChunks()

      Returns the total number of unknown BWF chunks attached to this BWF import descriptor.

      Returns:
        Number of unknown BWF chunks attached to this BWF descriptor.

    - #### clearUnknownBWFChunks

          void clearUnknownBWFChunks()

      Clear the unknown BWF chunks attached to this BWF import descriptor, omitting this optional property.

    - #### appendUnknownBWFChunk

          void appendUnknownBWFChunk(RIFFChunk chunk)
                              throws NullPointerException,
                                     ObjectAlreadyAttachedException

      Append a RIFFChunk to end of the list of unknown BWF chunks of this BWF import descriptor.

      Parameters:
        `chunk` - Chunk to append to the current list.
      Throws:
        `NullPointerException` - The chunk argument is `null`.
        `ObjectAlreadyAttachedException` - The chunk is already contained within the list of unknown BWF chunks of this BWF import descriptor.

    - #### prependUnknownBWFChunk

          void prependUnknownBWFChunk(RIFFChunk chunk)
                               throws NullPointerException,
                                      ObjectAlreadyAttachedException

      Prepend a RIFFChunk to the beginning of the list of unknown BWF chunks of this BWF descriptor.

      Parameters:
        `chunk` - Chunk to prepend to the current list.
      Throws:
        `NullPointerException` - The chunk argument is `null`.
        `ObjectAlreadyAttachedException` - The The chunk is already contained within the list of unknown BWF chunks of this BWF import descriptor.

    - #### insertUnknownBWFChunkAt

          void insertUnknownBWFChunkAt(@UInt32
                                       int index,
                                       RIFFChunk chunk)
                                throws NullPointerException,
                                       IndexOutOfBoundsException,
                                       ObjectAlreadyAttachedException

      Insert a RIFFChunk into the list of unknown BWF chunks of this BWF import descriptor at the given index. Chunks already existing at the given and higher indices will be moved to the next higher index to accommodate the new chunk.

      Parameters:
        `index` - Index through the list of unknown BWF chunks at which to insert the additional chunk.
        `chunk` - Chunk to insert at the given index.
      Throws:
        `NullPointerException` - The chunk argument is `null`.
        `IndexOutOfBoundsException` - The given index is outside the acceptable range for the current list of unknown BWF chunks of this BWF import descriptor.
        `ObjectAlreadyAttachedException` - The given chunk is already contained in the list of unknown BWF chunks of this BWF import descriptor.

    - #### getUnknownBWFChunkAt

          RIFFChunk getUnknownBWFChunkAt(@UInt32
                                         int index)
                                  throws IndexOutOfBoundsException

      Returns the RIFFChunk from the list of unknown BWF chunks of this BWF import descriptor at the given index.

      Parameters:
        `index` - Index of the chunk to retrieve.
      Returns:
        Chunk at the given index into the list of unknown BWF chunks of this BWF import descriptor.
      Throws:
        `IndexOutOfBoundsException` - The given index is outside the acceptable range for the current list of unknown BWF chunks of this BWF import descriptor.

    - #### removeUnknownBWFChunkAt

          void removeUnknownBWFChunkAt(@UInt32
                                       int index)
                                throws IndexOutOfBoundsException

      Removes the RIFFChunk at the given index through the list of unknown BWF chunks of this BWF descriptor. Chunks already existing at indices higher than the given index will be moved to the next lower index to fill the gap left by the removal.

      Parameters:
        `index` - Index of the chunk to remove.
      Throws:
        `IndexOutOfBoundsException` - The given index is outside the acceptable range for the current list of unknown BWF chunks of this BWF import descriptor.

    - #### getUnknownBWFChunks

          List<? extends RIFFChunk> getUnknownBWFChunks()
                                                 throws PropertyNotPresentException

      Returns a copy of the list of unknown BWF chunks of this BWF import descriptor. This is an optional property.

      Returns:
        Shallow copy of the list of unknown BWF chunks of this BWF import descriptor.
      Throws:
        `PropertyNotPresentException` - The optional list of unknown BWF chunks is not present for this BWF import descriptor.
      See Also:
        `TypeDefinitions.RIFFChunkStrongReferenceVector`

    - #### setCodingHistory

          void setCodingHistory(String codingHistory)

      Sets the coding history property of this BWF import descriptor, which is taken from the coding history property of the associated <bext> chunk. This property is optional and setting it to `null` will omit the property.

      Parameters:
        `codingHistory` - Coding history property of this BWF import descriptor.

    - #### getCodingHistory

          String getCodingHistory()
                           throws PropertyNotPresentException

      Returns the coding history property of this BWF import descriptor, which is taken from the coding history property of the associated <bext> chunk. This property is optional.

      Returns:
        Coding history property of this BWF import descriptor.
      Throws:
        `PropertyNotPresentException` - The optional coding history property is not present in this BWF import descriptor.

    - #### setBasicData

          void setBasicData(String basicData)

      Sets the basic data of this BWF import descriptor, which is taken from the basic data property of the associated <qlty> chunk. This property is optional and setting it to `null` will omit the property.

      Parameters:
        `basicData` - Basic data of this BWF import descriptor.

    - #### getBasicData

          String getBasicData()
                       throws PropertyNotPresentException

      Returns the basic data of this BWF import descriptor, which is taken from the basic data property of the associated <qlty> chunk. This property is optional.

      Returns:
        Basic data of this BWF import descriptor.
      Throws:
        `PropertyNotPresentException` - The optional basic data property is not present in this BWF import descriptor.

    - #### setStartOfModulation

          void setStartOfModulation(String startOfModulation)

      Sets the start of modulation data of this BWF import descriptor, which is taken from the start modulation data property of the associated <qlty> chunk. This property is optional and setting it to `null` will omit the property.

      Parameters:
        `startOfModulation` - Start of modulation data of this BWF import descriptor.

    - #### getStartOfModulation

          String getStartOfModulation()
                               throws PropertyNotPresentException

      Returns the start of modulation data of this BWF import descriptor, which is taken from the start modulation data poperty of the associated <qlty> chunk. This property is optional.

      Returns:
        Start of modulation data of this BWF import descriptor.
      Throws:
        `PropertyNotPresentException` - The optional start of modulation property is not present in this BWF import descriptor.

    - #### setQualityEvent

          void setQualityEvent(String qualityEvent)

      Sets the quality event data property of this BWF import descriptor, which is taken from the quality event data property of the associated <qlty> chunk. This property is optional and setting it to `null` will omit the property.

      Parameters:
        `qualityEvent` - Quality event data property of this BWF import descriptor.

    - #### getQualityEvent

          String getQualityEvent()
                          throws PropertyNotPresentException

      Returns the quality event data property of this BWF import descriptor, which is taken from the quality event data property of the associated <qlty> chunk. This property is optional.

      Returns:
        Quality event data property of this BWF import descriptor.
      Throws:
        `PropertyNotPresentException` - The optional quality event property is not present in this BWF import descriptor.

    - #### setEndOfModulation

          void setEndOfModulation(String endOfModulation)

      Sets the end of modulation property of this BWF import descriptor, which is taken from the end modulation data property of the associated <qlty> chunk. This property is optional and setting it to `null` will omit the property.

      Parameters:
        `endOfModulation` - End of modulation property of this BWF import descriptor.

    - #### getEndOfModulation

          String getEndOfModulation()
                             throws PropertyNotPresentException

      Returns the end of modulation property of this BWF import descriptor, which is taken from the end modulation data property of the associated <qlty> chunk. This property is optional.

      Returns:
        End of modulation property of this BWF import descriptor.
      Throws:
        `PropertyNotPresentException` - The optional end of modulation property is not present in this BWF import descriptor.

    - #### setQualityParameter

          void setQualityParameter(String qualityParameter)

      Sets the quality parameter property of this BWF import descriptor, which is taken from the quality parameter data property of the associated <qlty> chunk. This property is optional and setting it to `null` will omit the property.

      Parameters:
        `qualityParameter` - Quality parameter property of this BWF import descriptor.

    - #### getQualityParameter

          String getQualityParameter()
                              throws PropertyNotPresentException

      Returns the quality parameter property of this BWF import descriptor, which is taken from the quality parameter data property of the associated <qlty> chunk. This property is optional.

      Returns:
        Quality parameter property of this BWF import descriptor
      Throws:
        `PropertyNotPresentException` - The optional quality parameter property is not present in this BWF import descriptor.

    - #### setOperatorComment

          void setOperatorComment(String operatorComment)

      Sets the operator comment property of this BWF import descriptor, which is taken from the comment of operator property of the associated <qlty> chunk. This property is optional and setting it to `null` will omit the property.

      Parameters:
        `operatorComment` - Operator comment of this BWF import descriptor.

    - #### getOperatorComment

          String getOperatorComment()
                             throws PropertyNotPresentException

      Returns the operator comment property of this BWF import descriptor, which is taken from the comment of operator property of the associated <qlty> chunk. This property is optional.

      Returns:
        Operator comment property of this BWF import descriptor.
      Throws:
        `PropertyNotPresentException` - The optional operator comment property is not present in this BWF import descriptor.

    - #### setCueSheet

          void setCueSheet(String cueSheet)

      Sets the cue sheet property of this BWF import descriptor, which is taken from the cue sheet data property of the associated <qlty> chunk. This property is optional and setting it to `null` will omit the property.

      Parameters:
        `cueSheet` - Cue sheet property of this BWF import descriptor.

    - #### getCueSheet

          String getCueSheet()
                      throws PropertyNotPresentException

      Returns the cue sheet property of this BWF import descriptor, which is taken from the cue sheet data property of the associated <qlty> chunk. This property is optional

      Returns:
        Cue sheet property of this BWF import descriptor.
      Throws:
        `PropertyNotPresentException` - The optional cue sheet property is not present in this BWF import descriptor.

    - #### clone

          BWFImportDescriptor clone()

      Create a cloned copy of this BWF import descriptor.

      Specified by:
        `clone` in interface `EssenceDescriptor`
      Specified by:
        `clone` in interface `ImportDescriptor`
      Specified by:
        `clone` in interface `InterchangeObject`
      Specified by:
        `clone` in interface `MediaEntity`
      Specified by:
        `clone` in interface `PhysicalDescriptor`
      Returns:
        Cloned copy of this BWF import descriptor.

(c)2007-2016 Richard Cartwright, all rights reserved. Licensed under Apache 2 license and subject to the AMWA IPR policy.